<?php
//======================================================================
// TinyTimeLine Version.2.41 by JUD at 2012/5/22
// http://judstyle.jp/wiki/TinyTimeLine
//======================================================================
require_once("./ttlsettings.php"); // Local Settings
require_once("./ttlinit.php"); // Initialize
$me="./".basename(__FILE__); // filename of myself

//======================================================================
outHTMLHead();
$POSTRESULT="";
$POSTREPORT="";
$ZR="";

if( $AUTH=="OK" || $AUTH=="CONTINUE" ){
	$APT = askPostType($METHOD,$ACTION,$TWEET);
	$AFT = askFormType($METHOD,$ACTION);
	$ATT = askTimelineType($METHOD,$ACTION);
	$AST = askStatusType($ACTION);
	//echo "Param(Post,Form,Timeline,Status): [".$APT."/".$AFT."/".$ATT."/".$AST."]<br>\n";
	//echo "TID: [".$TID."]<br>\n";

	// Post群
	if( "NO" != $APT && "POST"==$METHOD ){
		if( "POST"==$METHOD ){ // Post
			$POSTRESULT=postTweet($ACTION,$TWEET,$TID);
			if( "NG" == $POSTRESULT ){ // for Retry
				if("RE"==$APT||"QT"==$APT){
					$ATT="1"; $AFT=$APT;
				}
			}else{
				$TWEET="";
				$TID="";
			}
		}
	}
	if( "1"==$ATT ){ // GET for RE/QT
		$XR = get1Text($TID);
		if(0==strlen($TWEET)){
			$TWEET = editREQT($ACTION,$XR);
		}
	}

	// Form出力
	outTweetForm($AFT,$TWEET,$TID);

	// PostResult出力
	if( 0<strlen($POSTRESULT) ) outResult($POSTRESULT,$POSTREPORT);

	// TimeLine出力
	if("NL"!=$ATT){
		do{ // さくら等PHP5.3未満はgotoが使えないためループで処理
			if( "1"!=$ATT ){
				for($I=0;$I<$RETRY24TIME;$I++){
					$XR = getTimeline($ATT,$PAGE,$TID,$USER);
					if("24"!=$ACTION) break; // 24以外はretryしない
					if(0==strlen($XR->error)) break; // 正常
					sleep($RETRY24SEC);
				}
			}
			$TL = outTimeLine($ATT,$PAGE,$XR);
			echo $TL;
			if( "24"==$ACTION && 0<strlen($TL) ){
				if( "enable"==$_GET["postmail"] ){
					postMail($tpt,$tpf,$PM);
				}
			}
			if("ALL"==$ATT){ // ALL表示時は引き続きMentionsを表示
				if("FP"==$AGENT) break; // ガラケーではME/RT表示しない
				if(0<$PAGE) break; // HOMEの2頁目以降ではME/RT省略
				echo "<hr>\n"; $ATT = "ME";
			}else if("ME"==$ATT){ // Mentions表示時は引き続き被RTを表示
				echo "<hr>\n"; $ATT = "RT";
			}else{
				break;
			}
		}while(TRUE);
	}

	if("DEBUG"==$ACTION) executeDebug();

	if("LI"==$ATT){ // リスト出力時のリスト対象一覧出力
		echo "<hr>\n"; outListTarget($USER);
	}

	// ユーザ情報出力
	if( ""!=$AST ){
		if("MY"==$AST) $XU=getMyProfile(); else $XU=$XR->status->user;
		echo "<hr>\n"; outStatus($AST,$XU);
	}

}else{
	outAuthForm();
}
outHTMLTail($PAGE,$AUTH,$ATT);

//======================================================================
// Functions
//----------------------------------------------------------------------
function postTweet($ACTION,$TWEET,$TID){
	global $POSTREPORT;
	//echo $ACTION."/".$TWEET."/".$TID."<br>\n";
	$XR=upTwit($ACTION,$TWEET,$TID);
	if( ""==$XR ){
		$RV="NG";
		$POSTREPORT="ERROR in unknown, twit is ".intval(strlenMB($TWEET))." charactors.";
	}else if(0==strlen($XR->error)){
		$RV="OK";
		$POSTREPORT="Success tweet, #".$XR->id.".\n";
	}else{
		$RV="NG";
		$POSTREPORT="ERROR, [".$XR->error."], ".intval(strlenMB($TWEET))." charactors.";
	}
	return $RV;
}
//----------------------------------------------------------------------
function postMail($ATO,$AFR,$TX){
	mb_language("japanese");
	mb_internal_encoding("UTF-8");
	$subject = "Today's Tweets";
	$sendr = mb_send_mail($ATO,$subject,$TX,"From:".$AFR);
	echo "to : ".$ATO."<br>\n";
	echo "from : ".$AFR."<br>\n";
	echo "subject : ".$subject."<br>\n";
	echo "contents : ".$TX."<br>\n";
	if( $sendr != TRUE ){
		echo "<b>ERROR, failed post.</b>";
	}else{
		echo "<b>OK, posted.</b>";
	}
	echo "\n";
}
//----------------------------------------------------------------------
function outResult($POSTRESULT,$POSTREPORT){
	echo $POSTREPORT."<br>\n";
}
//----------------------------------------------------------------------
function outTimeLine($ACTION,$PAGE,$XR){
	global $tll, $ttm, $ttr, $BSN;
	$OUTLIMIT=0; $BSN="";
	if("24"==$ACTION) return out24Line($ACTION,$PAGE,$XR);
	$RV.="<dl>";
	if( "1"!=$ACTION ){ // TimeLine出力
		$TLS=$tll*$PAGE;
		$TLA=$TLS+$tll;
		for($TLC=$TLS; $TLC<$TLA; $TLC++){
			if( ""!=$XR->status[$TLC] ){ // 削除済みのstatusをskip
				$XI = $XR->status[$TLC];
				$RV.= out1Text($XI,TRUE,FALSE,$ACTION,$OUTLIMIT);
				// Me/RTでは2件目以降表示期限をチェック
				if("ME"==$ACTION) $OUTLIMIT=$ttm;
				if("RT"==$ACTION) $OUTLIMIT=$ttr;
			}
		}
	}else{
		$RV.= out1Text($XR,TRUE,TRUE,$ACTION,0);
		$RV.= outStatURL($XR,TRUE,TRUE);
		$RV.= out1RT($XR->id,$XR->retweet_count);
	}
	$RV.="</dl>\n";

	return $RV;
}
//----------------------------------------------------------------------
function outStatURL($XR,$DDTAG,$LINK){ // XML,DDタグ有無,LINK有無
	// http://twitter.com/HiromitsuTakagi/status/146253018176823297
	$URL ="http://twitter.com/".$XR->user->screen_name;
	$URL.="/status/".$XR->id;
	$RV="";
	if(TRUE===$DDTAG) $RV.="<dd>";
	$RV.=$URL;
	if(TRUE===$LINK)
		$RV.=" - <a href=\"".$URL."\" target=\"_blank\">[Twitter]</a>";
	if(TRUE===$DDTAG) $RV.="</dd>";
	return $RV;
}
//----------------------------------------------------------------------
function out24Line($ACTION,$PAGE,$XR){
	global $tld, $GETLIMIT;
	$RV="";
	for($TLC=$tld-1; $TLC>=0; $TLC--){
		$XI = $XR->status[$TLC];
		if( ""!=$XI ){ // 削除済みのstatusをskip
			$RV.= out1Text($XI,TRUE,FALSE,$ACTION,$GETLIMIT);
		}
	}
	return $RV;
}
//----------------------------------------------------------------------
function getTimeline($ACTION,$PAGE,$TID,$USER){
	global $tll, $tld, $tlm, $tlr;
	if("NL"==$ACTION){
		return "";
	}else if(""==$ACTION||"ALL"==$ACTION){
		$XR = getHomeLine($tll*($PAGE+1));
	}else if("LI"==$ACTION){
		$XR = getListLine($tll*($PAGE+1),$USER);
	}else if("ME"==$ACTION){
		$XR = getMentions($tlm);
	}else if("US"==$ACTION){
		$XR = getUserLine($tll*($PAGE+1),$USER);
	}else if("24"==$ACTION){
		$XR = getUserLine($tld*($PAGE+1),NULL);
	}else if("RT"==$ACTION){
		$XR = getRTLine($tlr);
	}else{
		return "";
	}
	return $XR;
}
//----------------------------------------------------------------------
// Status1件表示 XML,ReQT出力是非,Detail出力是非,ACTION,表示期限
function out1Text($XR,$RQ,$DT,$ACTION,$LIM){
	global $BSN, $me;
	$RV="";
	$dv = date2date($XR->created_at,$LIM);
	if("NG"==$dv) return; // 表示期限切れ
	if("24"==$ACTION){ // TDL
		$RV.= ltrim(outTwit2Html($XR,TRUE,FALSE));
		$RV.= " <small>- ".$dv."</small><br>\n";
	}else{
		if("RT"==$ACTION){
			$RV.= "<dt><a id=\"ba\" href=\"".$me."?act=RE&tid=".$XR->id."\"><b>RT(".$XR->retweet_count.")</b></a></dt>\n";
		}else{
			$CSN = rtrim($XR->user->name);
			if( $CSN!=$BSN ){ // ユーザ名重複表示抑止
				$RV.= "<dt><b>".editName($XR,TRUE)."</b></dt>\n";
			}
		}
		$RV.= "<dd>".ltrim(outTwit2Html($XR,$DT,TRUE));
		if( TRUE==$RQ ){
			$RV.= " - ".outReply2Html($XR->id);
			$RV.= " <small>- ".$dv."</small>";
		}
		$RV.= "</dd>\n";
	}
	$BSN = $CSN;
	return $RV;
}
//----------------------------------------------------------------------
function outStatus($ACTION,$XU){ // ユーザ情報出力
	global $ACTION;
	echo "<dl>";
	echo "<dt>".$XU->name." (@".$XU->screen_name.")";
	echo " #".$XU->id."</dt>\n";
	if( 0<strlen($XU->url) )
		echo "<dd><a href=\"".$XU->url."\">".$XU->url."</a></dd>\n";
	echo "<dd>".$XU->friends_count." following.</dd>\n";
	echo "<dd>".$XU->followers_count." followers.</dd>\n";
	if( "false"!=$XU->description ){
		$DESC=strtr($XU->description,"\t\r\n","   ");
		echo "<dd>".outText2Html($DESC,TRUE,FALSE)."</dd>\n";
	}
	if( "false"!=$XU->location )
		echo "<dd>".$XU->location."</dd>\n";
	if( "false"!=$XU->protected )
		echo "<dd><b>Protected.</b></dd>\n";
	echo "</dl>";
	// ユーザ詳細情報出力
	outLists($XU->screen_name); // リスト一覧出力
	if("HOME"!=$ACTION){ // HOMEはフォロワー一覧を出さない
		outFollowers($XU->screen_name); // フォロワー一覧出力
	}
}
//----------------------------------------------------------------------
function outFollowers($SNAME){ // リスト一覧
	global $me, $stf;
	$oc=0;
	echo "<dl>";
	echo "<dt>Newest ".strval($stf)." Followers (@".$SNAME.")</dt>\n";
	$XU=getFollowers($stf,$SNAME);
	if(0<strlen($XU->error)){
		echo "<dd>cannot get followers.</dd>\n</dl>\n";
		return;
	}
	foreach($XU->user as $XE){
		if($XE->protected == "true") $PM=" *"; else $PM="";
		echo "<dd><a href=\"".$me."?act=US&user=".$XE->screen_name."\">@".$XE->screen_name."</a> ".$XE->name.$PM."</dd>\n";
		$oc++;
	}
	if(0==$oc) echo "<dd>no Follower.</dd>\n</dl>\n";
	echo "</dl>";
}
//----------------------------------------------------------------------
function outLists($SNAME){ // リスト一覧
	global $me, $stl;
	$oc=0;
	echo "<dl>";
	echo "<dt>Lists (@".$SNAME.")</dt>\n";
	$XL=getLists($stl,$SNAME);
	if(0<strlen($XL->error)){
		echo "<dd>cannot get lists.</dd>\n</dl>\n";
		return;
	}
	foreach($XL->lists->list as $XE){
		echo "<dd><a href=\"".$me."?act=LI&user=".$SNAME."&list=".$XE->slug."\">".$SNAME."/".$XE->name."</a> (".$XE->member_count.")</dd>\n";
		$oc++;
	}
	if(0==$oc) echo "<dd>no Public-List.</dd>\n</dl>\n";
	echo "</dl>";
}
//----------------------------------------------------------------------
function out1RT($TID,$RTN){ // RTed情報表示
	global $me, $stb;
	if($RTN<=0) return "";
	$RV ="<dd>".strval($RTN)." RT(s).</dd>";
	$XR = getRTBY($stb,$TID);
	if(0<strlen($XR->error)){
		$RV.="<dd>cannot get RTer-list.</dd>\n</dl>\n";
		return $RV;
	}
	foreach($XR->user as $XU){
		if($XU->protected == "true") $PM=" *"; else $PM="";
		$RV.="<dd><a href=\"".$me."?act=US&user=".$XU->screen_name."\">@".$XU->screen_name."</a> ".$XU->name.$PM."</dd>\n";
	}
	return $RV;
}
//----------------------------------------------------------------------
function outListTarget($SNAME){ // リスト対象者一覧
	global $me, $stl;
	echo "<dl>";
	$LNAME=getParam("list");
	echo "<dt>List @".$SNAME."/".$LNAME."</dt>\n";
	$XL=getListMembers($stl,$SNAME,$LNAME);
	if(0<strlen($XL->error)){
		echo "<dd>cannot get list.</dd>\n</dl>\n";
		return;
	}
	foreach($XL->users->user as $XU){
		if($XU->protected == "true") $PM=" *"; else $PM="";
		echo "<dd><a href=\"".$me."?act=US&user=".$XU->screen_name."\">@".$XU->screen_name."</a> ".$XU->name.$PM."</dd>\n";
	}
	echo "</dl>";
}
//----------------------------------------------------------------------
function askPostType($METHOD,$ACTION,$TWEET){ // 投稿の有無と形式
	if( "GET"==$METHOD ) return "NO";
	if( "DEBUG"==$ACTION ) return "NO";
	if( "Logout"==$ACTION ) return "NO";
	if( 0==strlen($TWEET) ) return "NO";
	if( "TW"==$ACTION || "RE"==$ACTION || "QT"==$ACTION ) return $ACTION;
	return "NO";
}
//----------------------------------------------------------------------
function askFormType($METHOD,$ACTION){ // 表示すべきFormの形式
	if( "DEBUG"==$ACTION ) return "NO";
	if( "NL"==$ACTION ) return "NL";
	if( "GET"==$METHOD ){
		if( "RE"==$ACTION ) return "RE";
		if( "QT"==$ACTION ) return "QT";
	}
	return "";
}
//----------------------------------------------------------------------
function askTimelineType($METHOD,$ACTION){ // Timelineの表示形式
	global $TLH;
	if( "NL"==$TLH ) return "NL"; // no timeline
	if( "NL"==$ACTION ) return "NL"; // no timeline
	if( "DEBUG"==$ACTION ) return "NL"; // no timeline
	if( "HOME"==$ACTION ) return "ALL"; // HOME
	if( "LI"==$ACTION ) return "LI"; // list
	if( "ME"==$ACTION ) return "ME"; // mention
	if( "US"==$ACTION ) return "US"; // user-timeline
	if( "24"==$ACTION ) return "24"; // 過去24時間
	if( "TW"==$ACTION ) return "ALL"; // POST
	if( "RE"==$ACTION || "QT"==$ACTION ){ // POST
		if( "GET"==$METHOD ) return "1"; else return "ALL";
	}
	return "";
}
//----------------------------------------------------------------------
function askStatusType($ACTION){ // ユーザ情報表示有無
	global $AGENT;
	if( "US"==$ACTION ) return "US";
	if( "HOME"==$ACTION ){
		if( "FP"==$AGENT ) return ""; // ガラケーでは出さない
		return "MY";
	}
	return "";
}
//----------------------------------------------------------------------
function outHTMLTail($TLG,$AUTH,$ATT,$PPL){
	global $txg, $TTL, $ACTION, $USER;
	$burl =$TTL."?act=".$ACTION;
	if("LI"==$ACTION||"US"==$ACTION){ $burl.="&user=".$USER; }
	if("LI"==$ACTION){ $burl.="&list=".getParam("list"); }
	echo "<br>";
	if( $AUTH=="OK" || $AUTH=="CONTINUE" ){
		if(""==$ACTION||"US"==$ACTION||"LI"==$ACTION||"HOME"==$ACTION){
			echo '<a href="'.$burl.'">New</a>';
			for($TLC=1; $TLC<$txg; $TLC++){
				$TLK=strval($TLC);
				$purl="&p=".$TLK;
				echo ' - <a href="'.$burl.$purl.'">['.$TLK.']</a>';
			}
			if(($TLG+1)<$txg){
				echo ' / <a href="'.$burl.'&p='.strval($TLG+1).'">';
				echo  'Next'.strval($PPL)."</a>\n";
			}
			echo " / ";
		}
		echo '<a href="'.$TTL.'?act=NL">'."Tw</a>";
		echo ' / <a href="'.$TTL.'?act=HOME">'."HOME</a>";
		echo ' / <a href="'.$TTL.'?act=ME">'."@ME</a>";
		echo ' / <a href="'.$TTL.'?act=24">'."TDL</a><br>\n";
	}
	echo "</body>\n";
	echo "</html>\n";
}
//----------------------------------------------------------------------
function outHTMLHead($ACTION){
	echo "<html>\n";
	echo "<head>\n";
	echo "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" />\n";
	echo "<meta http-equiv=\"Cache-Control\" content=\"no-cache\" />"; //for au
	echo "<title>TinyTimeLine</title>\n";
	echo "<link rel=\"stylesheet\" href=\"./ttl.css\" type=\"text/css\">\n";
	echo "</head>\n";
	echo "<body link=\"blue\" alink=\"blue\" vlink=\"blue\">\n";
	//echo "<body>\n";
}
//----------------------------------------------------------------------
function outTweetForm($ACTION,$TWEET,$TID){
	global $me, $fsz, $TTL, $TLH;
	if("NO"==$ACTION) return;
	if(0==strlen($ACTION)||"NL"==$ACTION) $TB="TW"; else $TB=$ACTION;
	$FS='<form name="ttl" method="POST" ACTION="'.$me.'">'."\n";
	$FS.='<textarea name="twit" rows="3" cols="'.$fsz.'" wrap="soft">';
	$FS.=$TWEET.'</textarea>';
	$FS.='<input type="hidden" name="tid" value="'.$TID.'"><br>';
	if("NL"==$TLH||"NL"==$ACTION){
		$FS.='<input type="hidden" name="tl" value="NL">';
	}
	$FS.='<input type="submit" name="act" value="'.$TB.'">';
	$FS.='<input type="submit" name="act" value="Logout">';
	$FS.=' <a href="'.$TTL.'?act=HOME">HOME</a>';
	$FS.=' / <a href="'.$TTL.'?act=ME">@ME</a>'."\n".'</form>'."\n";
	echo $FS;
}
//----------------------------------------------------------------------
// twitterに対するアクション
function getMyProfile(){ // 認証者情報取得
	$URI= "http://api.twitter.com/1/account/verify_credentials.xml";
	$XU = cTOCore($URI,"GET",NULL,"MY");
	return $XU;
}
function get1Text($TID){ // Text1件取得 ReID
	$URI= "http://api.twitter.com/1/statuses/show/".$TID.".xml";
	$PARAM = array( "include_entities" => "true" , "id" => $TID );
	$XR = cTOCore($URI,"GET",$PARAM,"1");
	return $XR;
}
function getHomeLine($TLA){ // HomeTimeLine取得
	$URI= "http://api.twitter.com/1/statuses/home_timeline.xml";
	$PARAM = array( "include_entities" => "true" , "count" => strval($TLA) );
	$XR = cTOCore($URI,"GET",$PARAM,"TIMELINE");
	return $XR;
}
function getUserLine($TLA,$TLN){ // UserTimeLine取得
	if(NULL!==$TLN){
		$URI= "http://api.twitter.com/1/statuses/user_timeline/".$TLN.".xml";
	}else{
		$URI= "http://api.twitter.com/1/statuses/user_timeline.xml";
	}
	$PARAM = array( "include_entities" => "true" , "count" => strval($TLA) , "include_rts" => "true" ); // V2.35
	$XR = cTOCore($URI,"GET",$PARAM,"USER");
	return $XR;
}
function getMentions($TLA){ // Mentions取得
	$URI= "http://api.twitter.com/1/statuses/mentions.xml";
	//$PARAM = array( "include_entities" => "true" );
	$PARAM = array( "include_entities" => "true" , "count" => strval($TLA) );
	// , "include_rts" => "true"
	$XR = cTOCore($URI,"GET",$PARAM,"MENTIONS");
	return $XR;
}
function getRTLine($TLA){ // 被RT取得
	$URI= "http://api.twitter.com/1/statuses/retweets_of_me.xml";
	$PARAM = array( "include_entities" => "true" , "count" => strval($TLA) );
	$XR = cTOCore($URI,"GET",$PARAM,"RT");
	return $XR;
}
function getRTBY($TLA,$TID){ // RT者一覧取得
	$URI= "http://api.twitter.com/1/statuses/".$TID."/retweeted_by.xml";
	$PARAM = array( "count" => strval($TLA) );
	$XR = cTOCore($URI,"GET",$PARAM,"RB");
	return $XR;
}
function getLists($TLA,$TLN){ // リスト一覧
	$URI= "http://api.twitter.com/1/".$TLN."/lists.xml";
	$PARAM = array( "count" => strval($TLA) );
	$XR = cTOCore($URI,"GET",$PARAM,"LISTS");
	return $XR;
}
function getListLine($TLA,$TLN){ // リストタイムライン
	$TLL=getParam("list");
	$URI= "http://api.twitter.com/1/".$TLN."/lists/".$TLL."/statuses.xml";
	$PARAM = array( "include_entities" => "true" , "per_page" => strval($TLA) , "include_rts" => "true" ); //V2.35
	$XR = cTOCore($URI,"GET",$PARAM,"LISTLINE");
	return $XR;
}
function getFollowers($TLA,$TLN){ // フォロワー一覧
	$URI= "http://api.twitter.com/1/statuses/followers/".$TLN.".xml";
	$PARAM = array( "user_id" => $TLN , "count" => strval($TLA) );
	$XR = cTOCore($URI,"GET",$PARAM,"FOLLOWERS");
	return $XR;
}
function getListMembers($TLA,$TLN,$TLL){ // リストメンバ一覧
	$URI= "http://api.twitter.com/1/".$TLN."/".$TLL."/members.xml";
	$PARAM = array( "include_entities" => "true" , "per_page" => strval($TLA) );
	$XR = cTOCore($URI,"GET",$PARAM,"LISTMEM");
	return $XR;
}
function upTwit($ACT,$TWS,$TID){ // 投稿 内容,[RE/QT/-],ReID
	$URI = "http://api.twitter.com/1/statuses/update.xml";
	$PARAM = array( "status" => stripslashes($TWS) );
	if( "RE"==$ACT && 0<strlen($TID) ){
		$PARAM += array( "in_reply_to_status_id" => $TID );
	}
	$XR = cTOCore($URI,"POST",$PARAM,"POST");
	return $XR;
}
//----------------------------------------------------------------------
function cTOCore($URI,$POST,$PARAM,$EXD){ // twitterAPIコア
	global $toatok, $toasec, $tockey, $tocsec;
	$TO = new TwitterOAuth($tockey,$tocsec,$toatok,$toasec);
	$XS = $TO->OAuthRequest( $URI, $POST, $PARAM );
//debugOutFile("./test-".$EXD.".xml",$XS);
	$XR = simplexml_load_string($XS);
	return $XR;
}
function debugOutFile($FN,$TX){
	$F = fopen($FN,"w");
	fwrite($F,$TX);
	fclose($F);
	return;
}
//----------------------------------------------------------------------
// 日付を返す。GETLIMIT以上の時間差がある場合はNGを返す。
// GETLIMITがゼロの場合はNGを返さない。
function date2date($CAT,$GETLIMIT){ // 日付編集
	$rv="NG";
	// XMLで示された時刻と現在時刻を比較
	$eD = explode(" ",$CAT);
	$eT = explode(":",$eD[3]);
	$mDY = intval($eD[5],10);
	if(       strcasecmp($eD[1],"Jan")==0 ){ $mDM=1;
	}else if( strcasecmp($eD[1],"Feb")==0 ){ $mDM=2;
	}else if( strcasecmp($eD[1],"Mar")==0 ){ $mDM=3;
	}else if( strcasecmp($eD[1],"Apr")==0 ){ $mDM=4;
	}else if( strcasecmp($eD[1],"May")==0 ){ $mDM=5;
	}else if( strcasecmp($eD[1],"Jun")==0 ){ $mDM=6;
	}else if( strcasecmp($eD[1],"Jul")==0 ){ $mDM=7;
	}else if( strcasecmp($eD[1],"Aug")==0 ){ $mDM=8;
	}else if( strcasecmp($eD[1],"Sep")==0 ){ $mDM=9;
	}else if( strcasecmp($eD[1],"Oct")==0 ){ $mDM=10;
	}else if( strcasecmp($eD[1],"Nov")==0 ){ $mDM=11;
	}else if( strcasecmp($eD[1],"Dec")==0 ){ $mDM=12;
	}else{ $mDM=0; }
	$mDD = intval($eD[2],10);
	$mTH = intval($eT[0],10);
	$mTM = intval($eT[1],10);
	$mTS = intval($eT[2],10);
	$mesT = mktime($mTH,$mTM,$mTS,$mDM,$mDD,$mDY);
	$nowL = time(); // 現在時刻
	$nowT = $nowL - idate("Z",$nowL); // 時差
	$diffT = $nowT - $mesT;
	$mesL = $mesT + idate("Z",$nowL); // statusの時刻をLocalTime化

	if( $GETLIMIT==0 || $diffT<=$GETLIMIT ){
		$rv = sprintf("%d",idate("m",$mesT));
		$rv = $rv."/".sprintf("%d",idate("d",$mesL));
		$rv = $rv."-".sprintf("%d",idate("H",$mesL));
		$rv = $rv.":".sprintf("%02d",idate("i",$mesL));
	}
	return $rv;
}
//----------------------------------------------------------------------
// 対象ユーザ名(表示用)を返す arg: XR, user-timelineへのリンク有無
function editName($XR,$LINK){
	global $me,$AGENT;
	$CSN = rtrim($XR->user->name);
	if($LINK===TRUE&&"FP"!=$AGENT){
		$C2N = rtrim($XR->user->screen_name);
		$RV="<a id=\"ba\" href=\"".$me."?act=US&user=".$XR->user->screen_name."\">".$CSN."</a>";
	}else{
		$RV=$CSN;
	}
	return $RV;
}
//----------------------------------------------------------------------
// URL/@付きHTML変換コア Text,URL詳細表示是非,screen_nameリンク是非
function outX2Html($TX,$DT,$AT){
	$IT=$TX;
	do{
		//echo "- [".$IT."]<br>\n";
		$TOL=strlen($IT); $S1P=0;
		$S2P=searchLinkStart($IT);
		if(0>$S2P){ $RV.=$IT; break;}
		$S1L=$S2P;
		$S2L=getLinkLen($IT,$S2P);
		if(-2==$S2L) $S2L=0;
		if(0<$S2L){
			$S3P=$S2P+$S2L; $S3L=$TOL-$S3P;
			$T2=makeLink(substr($IT,$S2P,$S2L),$DT,$AT);
		}else{
			$S3P=$S2P+1; $S3L=$TOL-$S3P;
			$T2="@";
		}
		$T1=substr($IT,$S1P,$S1L);
		$T3=substr($IT,$S3P,$S3L);
		//echo "s1:".$S1P."/".$S1L."[".$T1."]<br>\n";
		//echo "s2:".$S2P."/".$S2L."[".$T2."]<br>\n";
		//echo "s3:".$S3P."/".$S3L."[".$T3."]<br>\n";
		$RV.=$T1.$T2; $IT=$T3;
	}while(0<=$S2P);
	return $RV;
}
//----------------------------------------------------------------------
// URL/@付きHTML変換(Text) Text,URL詳細表示是非,screen_nameリンク是非
function outText2Html($TX,$DT,$AT){
	if( NULL===$TX ) return "";
	$RV=outX2Html($TX,$DT,$AT);
	return $RV;
}
//----------------------------------------------------------------------
// URL/@付きHTML変換(XML) 対象XML,URL詳細表示是非,screen_nameリンク是非
function outTwit2Html($XR,$DT,$AT){
	global $me,$AGENT;
	if( 0<strlen($XR->retweeted_status->user->screen_name) ){
		$TX = "[RT:@".$XR->retweeted_status->user->screen_name."] ";
		$TX.= $XR->retweeted_status->text;
	}else{
		$TX = $XR->text;
	}
	if("FP"==$AGENT) return $TX;
	foreach($XR->entities->urls->url as $XU){
		//$XU->url, display_url, expanded_url
		
		$TR=$XU->expanded_url;
		if(0<preg_match("/^https?:\/\/twitter\.com\/.*\/status\/[0-9]+$/",$TR)){
			$TR ="<a href=\"".$me."?act=QT&tid=";
			$TR.=substr($XU->expanded_url,1+strrpos($XU->expanded_url,"/"));
			$TR.="\" target=\"_blank\">[tweet]</a>";
		}
		$TX=str_replace($XU->url,$TR,$TX);
	}
	$RV=outX2Html($TX,$DT,$AT);
	return $RV;
}
//----------------------------------------------------------------------
function getLinkLen($TX,$PS){ // Link長さ取得 Text,開始位置
	global $SNMASK; // screen_name使用可能文字
	if("@"==substr($TX,$PS,1)){
		$RL=strspn($TX,$SNMASK,$PS+1);
		if(0>=$RL) return -2;
		return (1+$RL);
	}else if("http://"==substr($TX,$PS,7)){
		$epx=strlen($TX);
		$epb=strpos($TX," ",$PS);
		if(FALSE!==$epb) if($epb<$epx) $epx=$epb;
		$epd=strpos($TX,"　",$PS);
		if(FALSE!==$epd) if($epd<$epx) $epx=$epd;
		$epe=strpos($TX,")",$PS);
		if(FALSE!==$epe) if($epe<$epx) $epx=$epe;
		return ($epx-$PS);
	}
	return -1;
}
//----------------------------------------------------------------------
function searchLinkStart($TX){ // Link開始位置取得 Text
	$MAX=9999;
	$pos=$MAX;
	$pat=strpos($TX,"@");
	if(FALSE===$pat) $pat=$pos;
	if($pat<$pos) $pos=$pat;
	$pht=strpos($TX,"http://");
	if(FALSE===$pht) $pht=$pos;
	if($pht<$pos) $pos=$pht;
	if($MAX==$pos) return -1;
	return $pos;
}
//----------------------------------------------------------------------
// URLからドメイン抽出
function getURLDomain($TX){
	$IT=$TX;
	if("http://"==substr($IT,0,7)) $IT=substr($IT,7);
	if("https://"==substr($IT,0,8)) $IT=substr($IT,8);
	$slp=strpos($IT,"/");
	if(FALSE===$slp) return $IT;
	$IT=substr($IT,0,$slp);
	return $IT;
}
//----------------------------------------------------------------------
// Link作成 Text,URL詳細表示有無,screen_nameリンク是非
function makeLink($TX,$DT,$AT){
	global $me, $TWEETURL;
	$RV="";
	if("@"==$TX[0]){
		if(TRUE!==$AT) return $TX;
		$TN=substr($TX,1);
		$RV.="<a id=\"la\" href=\"".$me."?act=US&user=".$TN."\">".$TX."</a>";
	}else if(0<preg_match("/^https?:\/\//",$TX)){
		$DOM=getURLDomain($TX);
		if(0<preg_match($TWEETURL,$TX)){ // リンク先がtweetそのもの
			$TID=substr($TX,strrpos($TX,"/"));
			$RV.="<a id=\"la\" href=\"".$me."?act=RE&tid=".$TID."\" target=\"_blank\">";
		}else{
			$RV.="<a id=\"la\" href=\"".$TX."\" target=\"_blank\">";
		}
		if(TRUE==$DT) $RV.=$TX; else $RV.="[".$DOM."]";
		$RV.="</a>";
	}else{
		return $TX;
	}
	return $RV;
}
//----------------------------------------------------------------------
function outReply2Html($RI){ // ReQT出力
	global $me;
	$RV =' <a href="'.$me.'?act=QT&tid='.$RI.'">QT</a>';
	$RV.=' <a href="'.$me.'?act=RE&tid='.$RI.'">Re</a>';
	return $RV;
}
//----------------------------------------------------------------------
function editREQT($ACTION,$XR){ // ReQTのtextform初期値
	$QS = $XR->text;
	$QN = $XR->user->screen_name;
	if( 'QT'==$ACTION && 0<strlen($QS) ){
		$QX=' QT @'.$QN.' '.$QS;
	}elseif( 'RE'==$ACTION && 0<strlen($QS) ){
		$QX='@'.$QN.' ';
	}else{
		$QX='';
	}
	return $QX;
}
//----------------------------------------------------------------------
// mbstrlenが使えない環境で使う場合の解決 16進文字列化して数える
function strlenMB($SA){ // UTF-8文字列の文字数を数える
	$SH=bin2hex($SA); $SL=strlen($SH); $NC=0;
	for($SI=0;$SI<$SL;$SI+=2){
		$SC=substr($SH,$SI,1);
		if( $SC<'8' ){ $SK=0;
		}elseif( $SC<'e' ){ $SK=2;
		}elseif( $SC=='e' ){ $SK=4;
		}else{ $SD=substr($SH,$SI+1,1);
			if( $SD<'8' ){ $SK=6;
			}elseif( $SD<'c' ){ $SK=8;
			}else{ $SK=10; } }
		$SI+=$SK; $NC++; }
	return $NC;
}
//----------------------------------------------------------------------
function getParam($NAME){
	$METHOD=$_SERVER["REQUEST_METHOD"];
	if("POST"==$METHOD) $VALUE=$_POST[$NAME]; else $VALUE=$_GET[$NAME];
	return $VALUE;
}
//----------------------------------------------------------------------
function outDebugForm(){
	global $me;
	$gu=getParam("url"); if(0==strlen($gu)) $gu="http://api.twitter.com/1/";
	$g1n=getParam("p1n");
	$g1v=getParam("p1v");
	$g2n=getParam("p2n");
	$g2v=getParam("p2v");
	echo "DEBUG MODE.<br>\n";
	echo '<form name="ttldebug" method="POST" action="'.$me.'">';
	echo '<input type="text" name="url" size="80" value="'.$gu.'"><br>';
	echo '<input type="text" name="p1n" size="12" value="'.$g1n.'">';
	echo '<input type="text" name="p1v" size="12" value="'.$g1v.'"><br>';
	echo '<input type="text" name="p2n" size="12" value="'.$g2n.'">';
	echo '<input type="text" name="p2v" size="12" value="'.$g2v.'">';
	echo '<input type="hidden" name="act" value="DEBUG">';
	echo '<input type="hidden" name="mode" value="API"><br>';
	echo '<input type="submit" name="mt" value="GET">';
	echo '<input type="submit" name="mt" value="POST">';
	echo '</form>'."\n";
	return;
}
//----------------------------------------------------------------------
function executeDebug(){
	global $METHOD;
	//if("GET"==$METHOD) return outDebugForm();
	outDebugForm();
	outDebugTemplates();
	$mode = getParam("mode");
	if("API"==$mode){
		requestDebug();
	}
}
//----------------------------------------------------------------------
function outDebugTemplates(){
	echo "<table border=\"1\">\n";
	echo "<caption>Templates</caption>";
	echo "<tr><td>verify</td><td>http://api.twitter.com/1/account/verify_credentials.xml</td><td>&nbsp;</td><td>&nbsp;</td></tr>\n";
	echo "<tr><td>1</td><td>http://api.twitter.com/1/statuses/show/116434065225293824.xml</td><td>include_entities</td><td>&nbsp;</td></tr>\n";
	echo "<tr><td>home-timeline</td><td>http://api.twitter.com/1/statuses/home_timeline.xml</td><td>include_entities</td><td>count</td></tr>\n";
	echo "<tr><td>user-timeline</td><td>http://api.twitter.com/1/statuses/user_timeline.xml</td><td>include_entities</td><td>count</td></tr>\n";
	echo "<tr><td>user-timeline</td><td>http://api.twitter.com/1/statuses/user_timeline/<b>screen_name</b>.xml</td><td>include_entities</td><td>count</td></tr>\n";
	echo "<tr><td>mentions</td><td>http://api.twitter.com/1/statuses/mentions.xml</td><td>include_entities</td><td>count</td></tr>\n";
	echo "<tr><td>RTed-by</td><td>http://api.twitter.com/1/statuses/210289873125511168/retweeted_by.xml</td><td>&nbsp;</td><td>count</td></tr>\n";
	echo "<tr><td>RTed</td><td>http://api.twitter.com/1/statuses/retweets_of_me.xml</td><td>include_entities</td><td>count</td></tr>\n";
	echo "<tr><td>lists</td><td>http://api.twitter.com/1/<b>screen_name</b>/lists.xml</td><td>include_entities</td><td>count</td></tr>\n";
	echo "<tr><td>list-members</td><td>http://api.twitter.com/1/<b>screen_name</b>/<b>slug</b>/members.xml</td><td>include_entities</td><td>per_page</td></tr>\n";
	echo "<tr><td>list-timeline</td><td>http://api.twitter.com/1/<b>screen_name</b>/lists/<b>slug</b>/statuses.xml</td><td>include_entities</td><td>per_page</td></tr>\n";
	echo "</table><hr>\n";
	return;
}
//----------------------------------------------------------------------
function requestDebug(){
	$url = getParam("url"); if(0==strlen($url)) return;
	$g1n=getParam("p1n");
	$g1v=getParam("p1v");
	$g2n=getParam("p2n");
	$g2v=getParam("p2v");
	$MT = getParam("mt"); if(0==strlen($MT)) $MT="GET";
	echo "[".$MT." ".$url."]<br>\n";
	if(0>=preg_match("/^https?:\/\/api\.twitter\.com\//",$url)) return;
	//$PARAM = array( "include_entities" => "true" , "count" => strval(5) );
	$PARAM = array( $g1n => $g1v , $g2n => $g2v );
	$XR = cTOCore($url,$MT,$PARAM,"DEBUG");
	if(0<strlen($XR->error)){
		echo "ERROR, [".$XR->error."].<br>\n";
	}else{
		echo "<pre>\n";
		print_r($XR);
		echo "</pre><br>\n";
	}
}


?>
