<?php
//======================================================================
// TinyTimeLine Settings Version.2.x(later 2.34)
//======================================================================
// 設置時に記入すべき設定項目

// twitteroauthライブラリ設置場所 http://github.com/abraham/twitteroauth
require_once("./LIB/twitteroauth.php");
require_once("./ttlkeys.php");

$TTL="./index.php"; // filename of tinytimeline

// title表示
$CN="TinyTimeLine";

// screen_name に使用可能な文字
$SNMASK="_0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz";
// twitter.comのstatusをRE機能で表示するURLパターン for preg
$TWEETURL="/^https?:\/\/twitter\.com\/#\!\/[A-Za-z0-9_]+\/status\/[0-9]+/";

// 最近24時間の自分の発言 試行回数
$RETRY24TIME=3; // 試行回数
$RETRY24SEC=2; // 試行間隔

//----------------------------------------------------------------------
// 表示に関する設定項目

$tll=40; // Home,ユーザ,リスト各タイムライン取得Text数
$tlf=10; // Home,ユーザ,リスト各タイムライン取得Text数(ガラケー時)
$tlm=15; // Mentionsタイムライン取得Text数
$ttm=86400*4; // Mentions表示期限(最新の1件は期限切れでも表示)
$tlr=10; // Retweeted取得Text数
$ttr=86400*4; // Retweeted表示期限(最新の1件は期限切れでも表示)
$tld=100; // 最近24時間の自分の発言 最大取得Text数
$stl=50; // リスト一覧で表示可能な件数
$stf=40; // フォロワー一覧で表示可能な件数
$stb=100; // RT者一覧で表示可能な件数
$txg=4; // タイムライン取得可能世代数
$fsz="84"; // テキストボックスの大きさ
$fss="44"; // テキストボックスの大きさ(SP)



?>
